;-----------------------------------------------------
; Solar Assembler example for ELF64 object file
; using Linux native syscall interfaces
;
; build with:
;	 sol_asm2 -elf64 test.asm test.obj 
;
; link with:
;	ld -e _start test.obj
;
; run:
;	./a.out ; echo $?  
;-----------------------------------------------------

.use64


stdout		equ	1
sys_write 	equ	1
sys_exit	equ	60

;-------------------
; define sections
;-------------------
section "text"	 alias ".text"	class_code
section "data"	 alias ".data"	class_data


.data
	msg_elf		db	13,10,'Hi from Sol_Asm Linux native sample',13,10,0
	msg_len		equ	$-msg_elf

.text

.entry _start

_start:	
	; write message to stdout
	mov rdx,msg_len		; rdx = arg_03 = message len
	mov rsi,offset msg_elf	; rsi = arg_02 = message ptr
	mov rdi,stdout		; rdi = arg_01 = stdout

	; write (stdout, msg_ptr, msg_len);
	mov rax,sys_write
	syscall
	
	; exit with code 77h
	mov	rdi,77	
	mov	rax,sys_exit
	syscall
	
	ret

;----------------------------
; the end of this programm
;----------------------------

